import java.util.Calendar;

color[] palette = {#3014A2, #2B1680, #221168, #150949, #0C052B};
//color[] palette = {#FB5685, #FFCE58, #6780F4};
//color[] palette = {#FB5685};

String startTime = timestamp();

int maxCircles = 300;
int index = 0;
Circle[] circles = new Circle[maxCircles];

void setup(){
  size(600,600);
  smooth();
  background(0);
  noFill();
  blendMode(ADD);
  
  for(int i = 0; i < maxCircles; i++){
    circles[i] = new Circle(width/2, height/2);
    index = i;
    //println(circles[i].c);
  }
}

void draw(){
  background(0);
  //fill(0,50);  
  //rect(0,0,width,height);
   
  
   
  for(int i = 0; i < circles.length; i++){
    circles[i].move();
  }
  
  connectCircles();
  
  saveFrame("movie_" + startTime +"_#####.png");
}

void connectCircles(){
  for(int i = 0; i < index; i++){
    for(int j = i + 1; j < index; j++){
        float realDist = dist(circles[i].cX, circles[i].cY, circles[j].cX, circles[j].cY); 
        float minDist = (circles[i].d / 2) + (circles[j].d / 2);
        
        if(realDist < minDist){
          strokeWeight(10);
          stroke(circles[i].c,25);
          line(circles[i].cX, circles[i].cY, circles[j].cX, circles[j].cY);
        }
    }
  }
}

int randomSign(){
  float output = random(-1,1);
  if(output < 0){ output = -1;}
  else{ output = 1;}
  return int(output);
}



// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}