class Circle{
  float cX;
  float cY;
  float d = random(50,100);
  PVector direction = newRandomDirection();
  float speed = random(15,20);
  color c = palette[int(random(palette.length))];
  
  Circle(){
    this.cX = width / 2;
    this.cY = height / 2;
  }
  
  Circle(float cX, float cY){
    this.cX = cX;
    this.cY = cY;
  }
  
  void show(){
    ellipse(cX,cY,d,d);
  }
  
  void move(){
    this.cX += direction.x * speed;
    this.cY += direction.y * speed;
    
    if(cX > width+d || cX < -d || cY > height+d || cY < -d){
        
      cX = width/2;
      cY = height/2;
      
      //cX = random(width);
      //cY = random(height);
      
      //if(randomSign() == 1){cY = 0;}
      //else{cY = height;}
      
      direction = newRandomDirection();
    }
  }
  
  void mousePos(){
    cX = mouseX;
    cY = mouseY;
  }
  
  PVector newRandomDirection(){
    //return new PVector(random(-0.2,0.2), random(0.5,1) * randomSign());
    return new PVector(random(-1,1), random(-1,1));
  
  }
}